﻿using Styx.WoWInternals.WoWObjects;

namespace InnerRage.Core.Conditions
{
    internal class TargetIsInHealthRangeCondition : ICondition
    {
        private readonly int _maxHealthPercentage;
        private readonly int _minHealthPercentage;
        private readonly WoWUnit _target;

        public TargetIsInHealthRangeCondition(WoWUnit target, int minHealthPercentage = 0, int maxHealtPercentage = 100)
        {
            _target = target;
            _minHealthPercentage = minHealthPercentage;
            _maxHealthPercentage = maxHealtPercentage;
        }

        public bool Satisfied()
        {
            if (_minHealthPercentage > _maxHealthPercentage)
                throw new ConditionException("minHealth can't be bigger than maxHealth!");
            if (_maxHealthPercentage < _minHealthPercentage)
                throw new ConditionException("maxhealth can't be bigger than minhealth!");
            return _target != null && _target.HealthPercent >= _minHealthPercentage &&
                   _target.HealthPercent <= _maxHealthPercentage;
        }
    }
}